//Motor-Zeug



//Stepper definieren

const int fahrenRight = 2;
const int fahrenLeft = 3;
const int directionRight = 4;
const int directionLeft = 5;
int fahren = fahrenRight+fahrenLeft;

//Farbsensor Pins
#define S0 10
#define S1 9
#define S2 8
#define S3 7
#define sensorOut 6

//USM Pins
//links
const int trig1Pin = 18;
const int echo1Pin = 13;
//rechts
const int trig2Pin = 19;
const int echo2Pin = 16;



void setup() {
  
  

  // Farbsensor Pins
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);

  // Setting frequency-scaling to 20%
  digitalWrite(S0, HIGH);
  digitalWrite(S1, HIGH);


  //USM Pins
  //Links:
  pinMode(trig1Pin, OUTPUT);
  pinMode(echo1Pin, INPUT);
  digitalWrite(trig1Pin, LOW);
  //Rechts:
  pinMode(trig2Pin, OUTPUT);
  pinMode(echo2Pin, INPUT);
  digitalWrite(trig2Pin, LOW);

  //Stepper Fahren

  pinMode(fahrenRight, OUTPUT);
  pinMode(fahrenLeft, OUTPUT);
  pinMode(directionRight, OUTPUT);
  pinMode(directionLeft, OUTPUT);
  //xnachLinks(1130);
  //ynachRechts(1130);
 fahren(1131);
  
  Serial.begin(115200);

}

void loop() {
  void nachRechts() {
  digitalWrite(directionRight, HIGH);
  digitalWrite(fahrenRight, HIGH);
  //delay(100);
  delayMicroseconds(1000);
  digitalWrite(fahrenRight, LOW);
  //delay(100);
  delayMicroseconds(1000);

}

void nachLinks() {
  digitalWrite(directionLeft, LOW);
  digitalWrite(fahrenLeft, HIGH);
  //delay(100);
  delayMicroseconds(1000);
  digitalWrite(fahrenLeft, LOW);
  //delay(100);
  delayMicroseconds(1000);

}
void xnachLinks(int x) {
  for (int zaehler = 0; zaehler < x; zaehler++) {

    nachLinks();
  }

}

void ynachRechts(int y) {
  for (int zaehler = 0; zaehler < y; zaehler++) {

    nachRechts();
  }

}

void fahren(int x) {

  for (int i = 0; i < x; i++) {
    xnachLinks(1);
    ynachRechts(1);
  }
}

  if(USMLinks() > 20){
  stepper1.runSpeed(); 
  stepper2.runSpeed();
  }

  // Farbsensor

  //if (FrequenzBLAU > 15 && FrequenzROT > 10) {
  // Geradeaus();
  //}
  //if (FrequenzROT <= 10 ) {
  //Linksherum();
  // }
  // if (FrequenzBLAU <= 13) {
  //Rechtsherum();
  // }

  //Ultraschall messer

  //while (USMRechts() < 3 ) {
  // LSchneller();
  //}
  //while (USMLinks() < 3) {
  //RSchneller();
  // }
}


//FUNKTIONEN
//Stepper




// Farben

float Blau() {
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  float FrequenzBLAU = pulseIn(sensorOut, LOW);
  Serial.print("B= ");
  Serial.print(FrequenzBLAU);
  Serial.print("  ");
  Serial.print("\t");
  return (FrequenzBLAU);
}


float Rot() {
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
  float FrequenzROT = pulseIn(sensorOut, LOW);
  Serial.print("R= ");
  Serial.print(FrequenzROT);
  Serial.println("  ");
  return (FrequenzROT);
}


float Grun() {
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);
  float FrequenzGRUN = pulseIn(sensorOut, LOW);
  Serial.print("G= ");
  Serial.print(FrequenzGRUN);
  Serial.print("  ");
  Serial.print("\t");
  return (FrequenzGRUN);
}

//Ultraschallmesser

long USMLinks() {

  long Dauer1, cm1;
  digitalWrite(trig1Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig1Pin, LOW);
  Dauer1 = pulseIn(echo1Pin, HIGH, 1000000);
  // Zeit in Enternung
  cm1 = microsecondsToCentimeters(Dauer1);
  return (cm1);
}

long USMRechts() {

  long Dauer2, cm2;
  digitalWrite(trig2Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig2Pin, LOW);
  Dauer2 = pulseIn(echo2Pin, HIGH, 1000000);
  // Zeit in Entfernung
  cm2 = microsecondsToCentimeters(Dauer2);
  delay(10);
  return (cm2 );
}

long microsecondsToCentimeters(long microseconds)
{
  // The speed of sound is 340 m/s or 29 microseconds per centimeter.
  // The ping travels out and back, so to find the distance of the
  // object we take half of the distance travelled.
  return microseconds / 29 / 2;
}
